package com.changhong.epc.count.service.count.data.tool.impl;

import com.changhong.epc.bean.count.MasterInfo;
import com.changhong.epc.bean.tenant.bill.IOCRBill;
import com.changhong.epc.bean.tenant.master.MasterEleValue;
import com.changhong.epc.constter.system.SystemClients;
import com.changhong.epc.constter.system.run.EpcRestInterface;
import com.changhong.epc.constter.tenant.TenantUrlConst;
import com.changhong.epc.count.service.count.data.tool.ICorrelMaster;
import com.changhong.epc.count.service.count.model.UnitInfo;
import com.changhong.epc.rely.api.epc.tenant.MasterApi;
import com.iemsoft.framework.cloud.core.base.ResMsg;
import com.iemsoft.framework.cloud.core.tools.Assert;
import com.iemsoft.framework.cloud.core.tools.JSONTool;
import com.iemsoft.framework.cloud.core.tools.SpringUtil;
import com.iemsoft.framework.cloud.ribbon.RestInterface;
import lombok.extern.slf4j.Slf4j;
import org.apache.commons.lang3.StringUtils;
import org.springframework.stereotype.Service;

import java.util.*;

/**
 * 查找相关主数据
 * @author wangZX
 *
 */
@Slf4j
@Service("correlMaster")
public class CorrelMasterImpl implements SystemClients, ICorrelMaster<UnitInfo>{
	
	/**
	 * 
	 * @param fs
	 * @param parm
	 * @return
	 */
	@SuppressWarnings("unchecked")
	public Set<MasterInfo> getJoinMasRest(String fs,MasterInfo parm){
		Set<MasterInfo> res = new HashSet<>();
		Map<String,Object> param = new HashMap<>();
		param.put("defineCode", parm.getMdCode());
		//if(parm.getMeVal() instanceof String){
	//		param.put("mvCode", parm.getMeVal());
	//	}else if(parm.getMeVal() instanceof JSONArray){
	//		List<String> mevals = (List<String>)parm.getMeVal();
	//		// System.out.println("关联主数据:"+JSONTool.toJson(mevals));
	//		param.put("mvCode", mevals.get(0));
	//	}
		
		RestInterface restInterface = SpringUtil.getBean(SERVER_TENANT.getBeanName(), RestInterface.class);
		Object data = restInterface.post(fs, param, ResMsg.class, EpcRestInterface.getEpcHeads()).getData();
		List<MasterEleValue> list = JSONTool.toList(JSONTool.toJson(data), MasterEleValue.class);
		if(list ==null)
			return res;
		for (MasterEleValue masterEleValue : list) {
			
			MasterInfo mv = new MasterInfo();
			mv.setMdCode(masterEleValue.getDefineCode());
			mv.setMeVal(masterEleValue.getMvCode());
			res.add(mv);
		}
		return res;
	}
	
	/**
	 * 查找行程相关主数据
	 */
	@Override
	public Set<MasterInfo> addEachUnitMd(UnitInfo unitInfo) {
		log.debug("查找行程相关主数据！\n");
		Set<MasterInfo> unitall =  new HashSet<>();
		for (MasterInfo masterInfo : unitInfo.getUnitInfo()) {
			if(StringUtils.isBlank(masterInfo.getMdCode()))
				continue;
			//查询mdCode
			Set<MasterInfo> joinMasRest = getJoinMasRest(
					TenantUrlConst.REST_TENANT_MASTERELEMENT_SELECTCODE,
					masterInfo);
			log.debug("--------> " + joinMasRest);
			unitall.addAll(joinMasRest);
		}
		log.debug("\n查找行程相关主数据结束！\n");
		return unitall;
	}
	
	/**
	 * 查找票据相关主数据
	 */
	@Override
	public Set<MasterInfo> addEachBillMd(IOCRBill bill) {
		log.debug("查找票据相关主数据！\n");
		Set<MasterInfo> unitall =  new HashSet<>();
		for (MasterInfo masterInfo : bill.getMasterInfo()) {
			if(StringUtils.isBlank(masterInfo.getMdCode()))
				continue;
			Set<MasterInfo> joinMasRest = getJoinMasRest(
					TenantUrlConst.REST_TENANT_MASTERELEMENT_SELECTCODE,
					masterInfo);
			log.debug("--------> " + joinMasRest);
			unitall.addAll(joinMasRest);
		}
		log.debug("查找票据相关主数据结束！\n");
		return unitall;
	}

	@Override
	public Map<MasterEleValue, MasterEleValue> getJoinMasterInfos(Set<MasterEleValue> masterInfos) {
		if(log.isDebugEnabled())
			log.debug("开始查询关联主数据:{}", JSONTool.toJson(masterInfos));
		Collection<MasterEleValue> allJoinMi = SpringUtil.getBean(MasterApi.class).getMasterVal(masterInfos);
		// 验证请求是否成功
		Assert.empty(allJoinMi == null, "");

		Map<MasterEleValue, MasterEleValue> result = new HashMap<>();
		allJoinMi.stream().forEach(masterEleValue -> result.put(masterEleValue, masterEleValue));
		if(log.isDebugEnabled())
			log.debug("返回关联主数据:{}", JSONTool.toJson(result));
		return result;
	}

}
