package com.changhong.epc.count.service.count.model;

import com.changhong.epc.bean.tenant.norm.AppStanderDef;
import com.changhong.epc.bean.tenant.norm.SuppStander;
import com.changhong.epc.bean.tenant.norm.way.EleType;
import com.changhong.epc.bean.tenant.norm.way.Way;
import com.google.common.base.Objects;

import lombok.Data;
import lombok.EqualsAndHashCode;


@Data
@EqualsAndHashCode(callSuper=true)
public class SuppStanderCount extends SuppStander{
	
	/**
	 * 费用类型名称
	 */
	private String mdName = "交通费用";
	
	private Integer mdId;
	
	/**
	 * 报销方式名称
	 */
	private Way way;
	
	/**
	 * 结构为
	 * 	维度[0][0]  维度[0][1]  维度[0][2]  维度[0][3]
	 * 	维度[1][0]  维度[1][1]  维度[1][2]  维度[1][3]
	 * 	维度[2][0]  维度[2][1]  维度[2][2]  维度[2][3]
	 * 	维度[3][0]  维度[3][1]  维度[3][2]  维度[3][3]
	 */
	private MatrixList child;

	/**
	 * 获得维度二维数组
	 * @Title: getMatrix
	 
	 * @param @return    设定文件
	 * @return AppStanderCount[][]    返回类型
	 * @throws
	 */
	public AppStanderDef[][] getMatrix(){
		return child.toMatrix();
	}
	
	public MatrixList getChild() {
		return child;
	}

	public void setChild(MatrixList child) {
		this.child = child;
	}

	public String getMdName() {
		return mdName;
	}

	public void setMdName(String mdName) {
		this.mdName = mdName;
	}

	public Integer getMdId() {
		return mdId;
	}

	public void setMdId(Integer mdId) {
		this.mdId = mdId;
	}

	public Way getWay() {
		return way;
	}

	public void setWayName(Way wayName) {
		this.way = wayName;
	}
	private static String typeOf[] = {"","TJ","BZ","JE"};
	public Boolean isCoverType(Integer type){
		
		for (EleType bxType : way.getEleTypes()) {
			if(Objects.equal(bxType.toString(), typeOf[type])){
				return true;
			}
		}
		return false;
	}
}
