package com.changhong.epc.count.service.count.performer.impl;


import com.changhong.epc.bean.tenant.bill.IOCRBill;
import com.changhong.epc.bean.tenant.bill.OCRBillHeaderEntity;
import com.changhong.epc.count.service.count.data.paramiter.impl.ParamIter;
import com.iemsoft.framework.cloud.core.tools.ObjectUtil;
import lombok.extern.slf4j.Slf4j;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Service;

import java.util.Arrays;
import java.util.List;
import java.util.Map;

/**
 * 计算费用执行器（其他费用）
 */
@Slf4j
@Service("otherTypeParamIter")
@Scope("prototype")
public class OtherTypeParamIter extends ParamIter {

    public List<IOCRBill> getIOCRBill(OCRBillHeaderEntity billHead){
        if(ObjectUtil.empty(billHead.getBillBodyEntityList()))
            return Arrays.asList(new OtherTypeIOCRBill(billHead));
        return Arrays.asList(billHead.getBillBodyEntityList()
                .stream()
                .map(OtherTypeIOCRBill::new)
                .toArray(IOCRBill[]::new));
    }

    public static class OtherTypeIOCRBill implements IOCRBill{

        private IOCRBill iocrBill;

        public OtherTypeIOCRBill(IOCRBill iocrBill){
            this.iocrBill = iocrBill;
        }

        @Override
        public Double getBillMoney() {
            return iocrBill.getBillMoney();
        }

        @Override
        public Boolean getBillByType(String type) {
//            return iocrBill.getBillByType(type);
            return true;
        }

        @Override
        public String getExchangeRate() {
            return iocrBill.getExchangeRate();
        }

        @Override
        public void setExchangeRate(String exchangeRate) {
            iocrBill.setExchangeRate(exchangeRate);
        }

        @Override
        public String getBillType() {
            return iocrBill.getBillType();
        }

        @Override
        public String getBillCode() {
            return iocrBill.getBillCode();
        }

        @Override
        public Map<String, String> getBillKeyName() {
            return iocrBill.getBillKeyName();
        }

        @Override
        public void setBillKeyName(Map<String, String> billKeyName) {
            iocrBill.setBillKeyName(billKeyName);
        }

        @Override
        public Map<String, String> getBillKeyCode() {
            return iocrBill.getBillKeyCode();
        }

        @Override
        public Map<String, String> getBillMasterName() {
            return iocrBill.getBillMasterName();
        }

        @Override
        public Map<String, String> getBillMasterCode() {
            return iocrBill.getBillMasterCode();
        }

        @Override
        public Map<String, String> getBillOriginalInfo() {
            return iocrBill.getBillOriginalInfo();
        }

        @Override
        public void setCostType(CostType costType) {
            iocrBill.setCostType(costType);
        }

        @Override
        public CostType getCostType() {
            return iocrBill.getCostType();
        }

        @Override
        public void appendBill(IOCRBill bill) {
            this.iocrBill.appendBill(bill);
        }

        @Override
        public <T> boolean isAssignableFrom(Class<T> clazz) {
            return this.iocrBill.isAssignableFrom(clazz);
        }
    }

}
