package com.changhong.epc.count.service.format.impl;


import com.changhong.epc.bean.count.format.CpnInfo;
import com.changhong.epc.bean.tenant.norm.way.Way;
import com.changhong.epc.count.service.count.model.CountResult;
import com.iemsoft.framework.cloud.core.tools.MsgTool;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;

/**
 * @Author WangYX
 * @Description 对限额做处理
 * @Date 2019/1/10 下午4:34
 */
@Slf4j
@Service("formatXECount")
public class FormatXECount extends FormatBillDetailInfoCount {

    /**
     * @Author WangYX
     * @Description 获得补助金额
     * @Date 2019/1/10 下午4:37
     */
    @Override
    protected CpnInfo.CpnMsgInfo getNomrCpnMsgInfo(Double jpAmount, boolean validate, CountResult countResult){
        if(isXE(countResult)){
            if(countResult.getBillMoney() != null){
                validate = countResult.getBillMoney() >= countResult.getSAmount();
            }
            return new CpnInfo.CpnMsgInfo(MsgTool.get(NOMR_TITLE_NAME)
                    , toNumber(countResult.getSAmount())
                    , toNumber(jpAmount)
                    , validate);
        }
        return super.getNomrCpnMsgInfo(toNumber(jpAmount), validate, countResult);
    }

    /**
     * @Author WangYX
     * @Description 获得票据金额
     * @Date 2019/1/10 下午4:38
     */
    @Override
    protected CpnInfo.CpnMsgInfo getBillCpnMsgInfo(Double billMoney, boolean validate, CountResult countResult) {
        if(isXE(countResult)){
            if(countResult.getSAmount() != null){
                validate = countResult.getSAmount() > billMoney;
            }
            return super.getBillCpnMsgInfo(toNumber(billMoney), validate, countResult);
        }
        return super.getBillCpnMsgInfo(toNumber(billMoney), validate, countResult);
    }

    /**
     * @Author WangYX
     * @Description 是否是限额
     * @Date 2019/1/10 下午4:47
     */
    protected boolean isXE(CountResult countResult){
        return countResult != null && countResult.getWay() == Way.BZNXEBX && countResult.getSAmount() != null;
    }

}
