package com.changhong.epc.count.service.system.func.set.date;

import com.changhong.epc.count.service.system.func.set.AbsFuncSupper;
import com.changhong.epc.count.service.tool.SystemFunTool;
import com.googlecode.aviator.runtime.type.AviatorDouble;
import com.googlecode.aviator.runtime.type.AviatorObject;
import com.iemsoft.framework.cloud.core.tools.DateTool;

import java.util.Map;

/**
 * 获得小时
 * @author wangZX
 *
 */
public class GetHourFuntion extends AbsFuncSupper {

	@Override
	public AviatorObject call(Map<String, Object> env, AviatorObject arg1, AviatorObject arg2) {
	
		String maxDate 	= SystemFunTool.getStringVal(arg1, env);
		String minDate  = SystemFunTool.getStringVal(arg2, env);
		
		try{
			return new AviatorDouble(
					new Double((DateTool.stringToDate(maxDate).getTime() - DateTool.stringToDate(minDate).getTime())/(60*60*1000.0)).longValue());
		}catch(Exception e){
			return new AviatorDouble(0D);
		}
	}
	
	@Override
	public String getName() {
		return FUNC_DATE_GET_HOUR;
	}

	
	
	
	
	/**
	 * 获得年月日格式 yyyy-MM-dd
	 * 获得时分格式 "HH:mm"
	 * 获得年月日时分格式 "yyyy-MM-dd HH:mm
	 * @Title: getDate
	 * @param @param ji
	 * @param @param mdCode
	 * @param @return    设定文件
	 * @return String    返回类型
	 * @throws
	 */
	
}
