package com.changhong.epc.count.service.system.func.set.date;

import com.changhong.epc.count.service.system.func.set.AbsFuncSupper;
import com.changhong.epc.count.service.tool.SystemFunTool;
import com.googlecode.aviator.runtime.type.AviatorObject;
import com.iemsoft.framework.cloud.core.tools.DateTool;

import java.util.Calendar;
import java.util.Map;

/**
 * 获得月
 * @author wangZX
 *
 */
public class GetMonthFuntion extends AbsFuncSupper {

	@Override
	public AviatorObject call(Map<String, Object> env, AviatorObject arg1) {
	
		String date = SystemFunTool.getStringVal(arg1, env);

		try{
			Calendar c = Calendar.getInstance();
			c.setTime(DateTool.stringToDate(date));
			c.get(Calendar.MONTH);
			return getAviatorLong( new Long(c.get(Calendar.MONTH)+1L) );
		}catch(Exception e){
			return getAviatorLong(0);
		}
	}
	
	@Override
	public String getName() {
		return FUNC_DATE_GET_MONTH;
	}

	
	
	
	
	/**
	 * 获得年月日格式 yyyy-MM-dd
	 * 获得时分格式 "HH:mm"
	 * 获得年月日时分格式 "yyyy-MM-dd HH:mm
	 * @Title: getDate
	 * @param @param ji
	 * @param @param mdCode
	 * @param @return    设定文件
	 * @return String    返回类型
	 * @throws
	 */
	
}
